unit ParserStream;

{
    TParserStream v0.9
    The base class for parser streams used by the parsers. This method
    allows many access methods (eg file, memory, http) to be used by any
    parser without having to worry where the data is coming from.
    
    Copyright (C) 2000 Ciaran McCreesh

    This library is available as part of the hktreeview distribution from
    <http://hktreeview.sourceforge.net/> or from the author via email
    <keesh@users.sourceforge.net>. Currently there is no standalone version
    as such, but if you're prepared to wait there will probably be one
    in the future. Otherwise, tweak away :)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TChars = set of char;
  TParserStream = class(TComponent)
  private
    { Private declarations }
  protected
    { Protected declarations }
  public
    function EOD: boolean; virtual; abstract;
    function Position: integer; virtual; abstract;
    function Seek(Offset: longint; Origin: word): integer; virtual; abstract;
    function CurrentChar: char; virtual; abstract;
    function ScanChar(const c: char): boolean; virtual; abstract;
    function ScanStr(const s: string): boolean; virtual; abstract;
    function ScanChars(const c: TChars): boolean; virtual; abstract;
    function Lookahead(const s: string): boolean; virtual; abstract;
    function GetData(const offset, len: integer): string; virtual; abstract;
  published
    { Published declarations }
  end;

procedure Register;

implementation

{$R TPARSERSTREAM.DCR}

procedure Register;
begin
  RegisterComponents('Parsers', [TParserStream]);
end;

end.
 