unit SParser;
{
    TSParser v0.9
    Base class from which other parsers are descended. Nothing amazing
    here, just a frame.
    
    Copyright (C) 2000 Ciaran McCreesh

    This library is available as part of the hktreeview distribution from
    <http://hktreeview.sourceforge.net/> or from the author via email
    <keesh@users.sourceforge.net>. Currently there is no standalone version
    as such, but if you're prepared to wait there will probably be one
    in the future. Otherwise, tweak away :)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ParserStream;

type
  TSParser = class(TComponent)
  private
    fStr: TParserStream;
  protected
    { Protected declarations }
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function Position: integer;
    function LineNumber: integer;
    function EOD: boolean;
    function Seek(Offset: integer; Origin: Word): integer;
  published
    property Stream: TParserStream read fStr write fStr;
  end;

procedure Register;

implementation

{$R TSPARSER.DCR}

procedure Register;
begin
  RegisterComponents('Parsers', [TSParser]);
end;

{ TSParser }

constructor TSParser.Create(AOwner: TComponent);
begin
  inherited;
end;

destructor TSParser.Destroy;
begin
  inherited;
end;

function TSParser.EOD: boolean;
begin
  result := self.fStr.EOD;
end;

function TSParser.LineNumber: integer;
var
  p: integer;
begin
  result := 0;
  p := self.Position;
  self.Seek(0, soFromBeginning);
  while ((self.Position <= p) and (self.fStr.ScanChar(#$0a))) do
    inc(result);
  self.Seek(p, soFromBeginning);
{ TODO 2 -okeesh -cfunctionality : Add 'position in line' code }
end;

function TSParser.Position: integer;
begin
  result := self.fStr.Position;
end;

function TSParser.Seek(Offset: integer; Origin: Word): integer;
begin
  result := self.fStr.Seek(offset, origin);
end;

end.
