program cmtreeview;

{
    Tree View for HTML-Kit (Project Unit)
    This HTML-Kit plugin displays documents in a 'tree' view.

    Copyright (C) 2000 Ciaran McCreesh

    Get the latest version and futher information from the project website,
    <http://hktreeview.sourceforge.net/>, or email the author
    <keesh@users.sourceforge.net>. This project is known to compile under
    Delphi 5 Professional, older versions of Delphi may reject it.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

uses
  SysUtils,
  ComObj,
  HKPCore,
  Dialogs,
  Forms,
  cmtreeview1 in 'cmtreeview1.pas' {MainForm},
  cmtreeview2 in 'cmtreeview2.pas' {AboutForm},
  cmtreeview3 in 'cmtreeview3.pas' {ErrorForm};

const
  sIcon1 =
    'AAABAAEAEBAQAAAAAAAoAQAAFgAAACgAAAAQAAAAIAAAAAEABAAAAAAAwAAAAAAAAAAAAA' +
    'AAAAAAAAAAAAAAAAAAAACAAACAAAAAgIAAgAAAAIAAgACAgAAAwMDAAICAgAAAAP8AAP8A' +
    'AAD//wD/AAAA/wD/AP//AAD///8AAAAAAAAAAAAAAAAAAAAAAAd9AAAAAAAABwAAAAAAAA' +
    'AMcAAAAAAAAAcAAAAAAAAABwd9AAAAAAAHBwAAAAAAAAd5AAAAAAAABwAAAAAAAAAHfAAA' +
    'AAAAAAcAAAAAAAAABwwAAAAAAAAHAAAAAAAAAAkAAAAAAAAAAAAAAAAAAAD//wAA//8AAI' +
    'gBAAC//wAAgH8AAL//AACiDwAAr/8AAIgBAAC//wAAiD8AAL//AACoAQAAv/8AAKAfAAD/' +
    '/wAA';

resourcestring
  rsUsage = 'This is an HTML-Kit plugin and cannot run as a standalone '
    + 'application. Please launch it through the button on the [Tools] '
    + 'section of the plugins bar. Note that this plugin requires Build '
    + '290 or later to function.';

procedure hkp_Main;
var
  v: Variant;
  nPluginID: integer;
  nOutputMode: integer;
  sOutput: string;
  nMoveCursor: integer;
  nFormatTags: integer;
begin
  v := CreateOleObject('htmlkit.HTMLKitPluginsCore');
  nOutputMode := 1;
  sOutput := '';
  nMoveCursor := 0;
  nFormatTags := 0;
  nPluginID := v.hkp_DataGetInt(hkp_PLUGIN_ID, 1);
  if (nPluginID = 1) then begin
    Application.CreateForm(TMainForm, MainForm);
    Application.CreateForm(TAboutForm, AboutForm);
    Application.CreateForm(TErrorForm, ErrorForm);
    Application.Run;
  end;
  v.hkp_DataAdd(hkp_OUTPUT, sOutput);
  v.hkp_DataAddInt(hkp_MODE_OUTPUT, nOutputMode);
  v.hkp_DataAddInt(hkp_MODE_MOVE_TO_CARET, nMoveCursor);
  v.hkp_DataAddInt(hkp_MODE_PREPROCESS_FORMAT_TAGS, nFormatTags);
end;

procedure hkp_Register;
var
  v: Variant;
begin
  v := CreateOleObject('htmlkit.HTMLKitPluginsCore');
  v.hkp_DataSetGlobalSuffix('_1');

  v.hkp_DataAdd(hkp_NAME, 'cmTreeView');
  v.hkp_DataAdd(hkp_SECTION, 'Tools');

  v.hkp_DataAdd(hkp_VERSION, '0.9');
  v.hkp_DataAdd(hkp_AUTHOR, 'Ciaran McCreesh');
  v.hkp_DataAdd(hkp_COPYRIGHT_SHORT, '(c) 2000 Ciaran McCreesh. This program is protected by the GNU General Public License (version 2 or, at your option, any later version). Please see the documentation for more details.');
  v.hkp_DataAdd(hkp_EMAIL, 'keesh@users.sourceforge.net');
  v.hkp_DataAdd(hkp_URL_HOME, 'http://hktreeview.sourceforge.net/');
  v.hkp_DataAdd(hkp_URL_DOWNLOAD, 'http://sourceforge.net/projects/hktreeview/');
  v.hkp_DataAddInt(hkp_MODE_SHOW_STATUS, 0);
  v.hkp_DataAdd(hkp_DESCRIPTION, 'Tree View displays HTML and XML documents in a hierarchical or ''tree'' layout.');
  v.hkp_DataAdd(hkp_HINT, 'Display current HTML or XML document in a hierarchical layout.');
  v.hkp_DataAdd(hkp_MODE_ICON, '1');
  v.hkp_DataAdd(hkp_ICON_SMALL, sIcon1);
  v.hkp_DataAddInt(hkp_MODE_IN_TEXT_FULL, 1);

  v.hkp_DataSetGlobalSuffix('');
end;

begin
  Application.Initialize;
  Application.Title := 'Tree View for HTML-Kit';
  if ('/hkpreg' = ParamStr(1)) then
    hkp_Register
  else if ('/hkprun' = ParamStr(1)) then
    hkp_Main
  else if ('/tomford' = ParamStr(1)) then begin
    { This is the easter egg. Please don't tell people how to get
      at it, but you can brag that you've found it :) If you don't
      understand these jokes don't ask, they aren't funny. }
    Application.CreateForm(TErrorForm, ErrorForm);
    ErrorForm.LabelErrorKind.Caption :=
      'EEggError: Expected a sensible parameter but encountered a clueless moron.';
    ErrorForm.LabelErrorLocation.Caption :=
      'Kernel Ketchup, With the Delphi Manual, Near The Coffee Machine';
    ErrorForm.ButtonClose.Tag := 1;
    Application.Run;
  end else
    MessageDlg(rsUsage, mtError, [mbOK], 0);
end.


